package com.bsoft.api.service.Impl;

import com.bsoft.api.mapper.SerDiseaseMapper;
import com.bsoft.api.model.SerDisease;
import com.bsoft.api.model.respmodel.DiseaseLevel;
import com.bsoft.api.service.SerDiseaseService;
import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;

@Service
public class SerDiseaseServiceImpl implements SerDiseaseService {
    @Resource
    private SerDiseaseMapper serDiseaseMapper;

    @Override
    public List<DiseaseLevel> selectListByIdorLevel(String date, String diseaseCode,Integer level){
        List<DiseaseLevel> list = new ArrayList<>();
        if(diseaseCode!=null){
            list = selectById(date,diseaseCode);
        }else{
            list = selectByLevel(date,level);
        }
        return list;
    }

    @Override
    public List<SerDisease> selectByMdcName(String date, String mdcName) {
        return serDiseaseMapper.selectByMdcName(date,mdcName);
    }

    /**
     * 根据id查询父子级别列表
     * @param date 时间
     * @param diseaseCode ID
     * @return
     */
    private List<DiseaseLevel> selectById(String date, String diseaseCode){
        SerDisease disease = serDiseaseMapper.selectByCode(diseaseCode,date);
        if(disease==null){
            return null;
        }
        //查询父级菜单对象
        DiseaseLevel diseaseLevel = serDiseaseMapper.selectParentById(date,disease.getId().intValue());
        List<DiseaseLevel> parentList = new ArrayList<>();

        //查询同级菜单列表
        List<DiseaseLevel> serDiseaseList =  serDiseaseMapper.selectByParentId(date,disease.getParentId().intValue());
        List<DiseaseLevel> diseaseLevelList = new ArrayList<>();
        for (DiseaseLevel serDiseases: serDiseaseList) {
            DiseaseLevel diseaseLevel1 = new DiseaseLevel();
            //查询子级菜单列表
            if(serDiseases.getMdcCode().equals(diseaseCode)){
                List<DiseaseLevel> diseaseLevelList1 = serDiseaseMapper.selectSonById(date,disease.getId().intValue());
                diseaseLevel1.setDiseaseLevelList(diseaseLevelList1);
            }
            diseaseLevel1.setDate(serDiseases.getDate());
            diseaseLevel1.setId(serDiseases.getId());
            diseaseLevel1.setLevel(serDiseases.getLevel());
            diseaseLevel1.setMdcCode(serDiseases.getMdcCode());
            diseaseLevel1.setMdcName(serDiseases.getMdcName());
            diseaseLevel1.setMdcNum(serDiseases.getMdcNum());
            diseaseLevel1.setOrgId(serDiseases.getOrgId());
            diseaseLevel1.setOrgName(serDiseases.getOrgName());
            diseaseLevel1.setParentId(serDiseases.getParentId());
            diseaseLevelList.add(diseaseLevel1);
        }
        if(diseaseLevel!=null){
            diseaseLevel.setDiseaseLevelList(diseaseLevelList);
            parentList.add(diseaseLevel);
            return parentList;
        }else {
            return diseaseLevelList;
        }
    }

    /**
     * 根据等级查询所有该等级数据
     * @param date
     * @param level
     * @return
     */
    private List<DiseaseLevel> selectByLevel(String date, Integer level) {
        if(level==null){
            level=0;
        }
        return serDiseaseMapper.selectByLevel(date,level);
    }
}
